RCS_ID_C="$Id: amiga_libtables.c,v 3.3 1994/01/11 19:36:40 too Exp $";
/*
 * Copyright (c) 1993 AmiTCP/IP Group, <amitcp-group@hut.fi>
 *                    Helsinki University of Technology, Finland.
 *                    All rights reserved.
 * 
 * Created: Tue Feb 16 14:14:33 1993 too
 * Last modified: Tue Jan 11 21:35:30 1994 too
 * 
 * HISTORY 
 * $Log: amiga_libtables.c,v $
 * Revision 3.3  1994/01/11  19:36:40  too
 * Replaced SetDtableSize with getdtablesize.
 * Removed some functions now in SocketBaseTagList
 *
 * Revision 3.2  1994/01/08  17:40:09  too
 * Added sendmsg and recvmsg
 *
 * Revision 3.1  1994/01/04  14:26:29  too
 * Added new, release 3 functions (getdtablesize, gethostname,
 * gethostid, GetHErrno, SetNetError and SocketBaseTagList)
 *
 * Revision 1.20  1993/08/12  07:32:27  jraja
 * Changed ioctl to IoctlSocket (too).
 *
 * Revision 1.19  1993/06/12  08:57:05  too
 * Added Du2Socket()
 *
 * Revision 1.18  1993/06/04  11:16:15  jraja
 * Fixes for first public release.
 *
 */

#include <conf.h>

#include <exec/types.h>
#include <sys/param.h>
#include <api/amiga_raf.h>

typedef VOID (* REGARGFUN f_void)();

/*
 * Null used in both function tables
 */
extern VOID Null(VOID);

/*
 * "declarations" for ExecLibraryList_funcTable functions.
 */ 

extern REGARGFUN VOID ELL_Open();
extern REGARGFUN VOID ELL_Expunge();

f_void ExecLibraryList_funcTable[] = {
  ELL_Open,
  Null,		/* ELL_Close() is never called */
  ELL_Expunge,
  Null,		/* ELL_Reserved() */
  (f_void)-1
};

/*
 * "declarations" for userLibrary_funcTable functions.
 */ 
extern REGARGFUN VOID UL_Close();

extern REGARGFUN VOID _socket();
extern REGARGFUN VOID _bind();
extern REGARGFUN VOID _listen();
extern REGARGFUN VOID _accept();
extern REGARGFUN VOID _connect();
extern REGARGFUN VOID _sendto();
extern REGARGFUN VOID _send();
extern REGARGFUN VOID _recvfrom();
extern REGARGFUN VOID _recv();
extern REGARGFUN VOID _shutdown();
extern REGARGFUN VOID _setsockopt();
extern REGARGFUN VOID _getsockopt();
extern REGARGFUN VOID _getsockname();
extern REGARGFUN VOID _getpeername();

extern REGARGFUN VOID _IoctlSocket();
extern REGARGFUN VOID _CloseSocket();
extern REGARGFUN VOID _WaitSelect();
extern REGARGFUN VOID _SetSocketSignals();
extern REGARGFUN VOID _getdtablesize();  /* from V3 on */
/*extern REGARGFUN VOID _SetDTableSize(); */
extern REGARGFUN VOID _ObtainSocket();
extern REGARGFUN VOID _ReleaseSocket();
extern REGARGFUN VOID _ReleaseCopyOfSocket();
extern REGARGFUN VOID _Errno();
extern REGARGFUN VOID _SetErrnoPtr();

extern REGARGFUN VOID _Inet_NtoA();
extern REGARGFUN VOID _inet_addr();
extern REGARGFUN VOID _Inet_LnaOf();
extern REGARGFUN VOID _Inet_NetOf();
extern REGARGFUN VOID _Inet_MakeAddr();
extern REGARGFUN VOID _inet_network();

extern REGARGFUN VOID _gethostbyname();
extern REGARGFUN VOID _gethostbyaddr();
extern REGARGFUN VOID _getnetbyname();
extern REGARGFUN VOID _getnetbyaddr();
extern REGARGFUN VOID _getservbyname();
extern REGARGFUN VOID _getservbyport();
extern REGARGFUN VOID _getprotobyname();
extern REGARGFUN VOID _getprotobynumber();

extern REGARGFUN VOID _Syslog();

/* bsdsocket.library 2 extensions */
extern REGARGFUN VOID _Dup2Socket();

/* bsdsocket.library 3 extensions */
extern REGARGFUN VOID _sendmsg();
extern REGARGFUN VOID _recvmsg();
extern REGARGFUN VOID _gethostname();
extern REGARGFUN VOID _gethostid();
extern REGARGFUN VOID _SocketBaseTagList();

f_void UserLibrary_funcTable[] = {
  (f_void)Null,		/* Open() */
  UL_Close,
  (f_void)Null,		/* Expunge() */
  (f_void)Null,		/* Reserved() */

  _socket,
  _bind,
  _listen,
  _accept,
  _connect,
  _sendto,
  _send,
  _recvfrom,
  _recv,
  _shutdown,
  _setsockopt,
  _getsockopt,
  _getsockname,
  _getpeername,

  _IoctlSocket,
  _CloseSocket,
  _WaitSelect,
  _SetSocketSignals,
  _getdtablesize,	/* from V3 on */
/*  _SetDTableSize, */
  _ObtainSocket,
  _ReleaseSocket,
  _ReleaseCopyOfSocket,
  _Errno,
  _SetErrnoPtr,

  _Inet_NtoA,
  _inet_addr,
  _Inet_LnaOf,
  _Inet_NetOf,
  _Inet_MakeAddr,
  _inet_network,

  _gethostbyname,
  _gethostbyaddr,
  _getnetbyname,
  _getnetbyaddr,
  _getservbyname,
  _getservbyport,
  _getprotobyname,
  _getprotobynumber,
  _Syslog,
  
  /* bsdsocket.library 2 extensions */
  _Dup2Socket,

  /* bsdsocket.library 3 extensions */
  _sendmsg,
  _recvmsg,
  _gethostname,
  _gethostid,
  _SocketBaseTagList,
  (f_void)-1
};
